cities/urls.py
from django.urls.conf import path, re_path

from cities.views import cities, subscriptions, subscribe, unsubscribe, login, logout,\
    readme


app_name = 'cities'
urlpatterns = [
    path('', cities, name='cities-list'),
    path('subscriptions', subscriptions, name='subscriptions-list'),
    re_path(r'^unsubscribe/(?P<id>[0-9]+)/$', unsubscribe, name='unsubscribe'),
    re_path(r'^subscribe/(?P<id>[0-9]+)/$', subscribe, name='subscribe'),

    path('login', login, name='login'),
    path('logout', logout, name='logout'),
    path('readme', readme, name='readme')
]

project/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('cities.urls', namespace='cities'))
]

cities/models.py
from django.contrib.auth.models import User
from django.db import models


class City(models.Model):
    name = models.CharField('City name', max_length=100)
    country = models.CharField('Country name', max_length=100)
    temperature = models.SmallIntegerField('Temperature', null=True)
    
    class Meta:
        unique_together = ('name', 'country')

class Subscription(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    city = models.ForeignKey(City, on_delete=models.CASCADE)
    
    class Meta:
        unique_together = ('user', 'city')

cities/views.py
import os

from django.conf import settings, Settings
from django.contrib import messages
from django.contrib.auth import login as dj_login, logout as dj_logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.core.paginator import Paginator
from django.db.models.query_utils import Q
from django.http.response import HttpResponse
from django.shortcuts import render, get_object_or_404, redirect
from django.urls.base import reverse_lazy, reverse

import cities
from cities.decorators import empty_subscriptions, subscriptions_limit
from cities.models import City, Subscription


@login_required(login_url=reverse_lazy('cities:login'))
def cities(request):
    page = request.GET.get('page') or 1
    query = request.GET.get('query')
    cities = City.objects.filter(Q(name__icontains=query.strip()) | Q(country__icontains=query.strip())) if query else City.objects.all()
    if request.user.is_authenticated:
        cities = cities.exclude(id__in=Subscription.objects.filter(user_id=request.user.id).values_list('city_id', flat=True))
    cities = cities.order_by('country', 'name')
    paginator = Paginator(cities, settings.CITIES_PER_PAGE)
    page_queryset = cities.filter(id__in=paginator.page(page).object_list.values_list('id', flat=True))
    countries = list(set(page_queryset.values_list('country', flat=True)))
    return render(request, 'cities.html', {'cities':page_queryset, 'countries':countries, 'paginator':paginator.page(page)})

@login_required(login_url=reverse_lazy('cities:login'))
@subscriptions_limit
def subscribe(request, id):
    Subscription.objects.update_or_create(user=request.user, city=get_object_or_404(City, id=id))
    return redirect(reverse('cities:subscriptions-list'))

@login_required(login_url=reverse_lazy('cities:login'))
def unsubscribe(request, id):
    get_object_or_404(Subscription, user=request.user, city__id=id).delete()
    return redirect(reverse('cities:subscriptions-list'))

@login_required(login_url=reverse_lazy('cities:login'))
@empty_subscriptions
def subscriptions(request):
    cities = City.objects.filter(id__in=Subscription.objects.select_related('city').filter(user=request.user).values_list('city__id', flat=True))
    return render(request, 'subscriptions.html', {'cities':cities})

def login(request):
    if request.method == 'POST':
        try:
            email, password = request.POST.get('email'), request.POST.get('password')
            user = User.objects.get(email=email)
            assert user.check_password(password)
            dj_login(request, user)
            return redirect(reverse('cities:subscriptions-list'))
        except (User.DoesNotExist, AssertionError):
            messages.add_message(request, messages.WARNING, 'Login failed')
    return render(request, 'login.html', {})

@login_required(login_url=reverse_lazy('cities:login'))
def logout(request):
    dj_logout(request)
    return redirect(reverse('cities:cities-list'))

def readme(request):
    return HttpResponse(open(os.path.join(settings.BASE_DIR, 'README.md'), 'rb'))

cities/templates/cities.html
{%load common%}
{%include 'base.html'%}
{%block content%}
	<main role="main" class="container">
	    <form class="form-inline mt-2 mt-md-0">
	      <input name='query' class="form-control mr-sm-2" type="text" placeholder="Search" aria-label="Search">
	      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
	    </form>
		{%for country in countries%}
			<div class='row'>
				<div class='col'><h3>{{country}}<h3></div>
			</div>
			{%for city in cities|filter_by_country:country %}
				  <div class='row'>{{city.name}}{%if user.is_authenticated%}<a href='{% url "cities:subscribe" city.id%}'> + </a>{%endif%}</div>
			{%endfor%}
		{%endfor%}
	</main>
{%endblock%}

cities/templates/login.html
{%include 'base.html'%}
{%load static%}
{%block extra_css%}
	<link rel='stylesheet' href='{%static "login_form.css"%}'>
{%endblock%}
{%block content%}
	<main role="main" class="container text-center">
    <form class="form-signin" method='POST' action=''>
		{%csrf_token%}
      <img class="mb-4" src="https://getbootstrap.com/docs/4.0/assets/brand/bootstrap-solid.svg" alt="" width="72" height="72">
      <h1 class="h3 mb-3 font-weight-normal">Please sign in</h1>
      <label for="inputEmail" class="sr-only">Email address</label>
      <input name='email' type="email" id="inputEmail" class="form-control" placeholder="Email address" required autofocus>
      <label for="inputPassword" class="sr-only">Password</label>
      <input name='password' type="password" id="inputPassword" class="form-control" placeholder="Password" required>
      <button class="btn btn-lg btn-primary btn-block" type="submit">Sign in</button>
      <p class="mt-5 mb-3 text-muted">&copy; 2017-2018</p>
    </form>
	</main>
{%endblock%}

cities/templates/subscriptions.html
{%include 'base.html'%}
{%block content%}
	<main role="main" class="container">
		<table class="table">
		  <thead>
		    <tr>
		      <th scope="col">#</th>
		      <th scope="col">Country</th>
		      <th scope="col">City</th>
		      <th scope="col">Temperature</th>
		      <th scope="col"></th>
		    </tr>
		  </thead>
		  <tbody>
			{%for city in cities%}
			    <tr>
			      <th scope="row">{{forloop.index}}</th>
			      <td>{{city.country}}</td>
			      <td>{{city.name}}</td>
			      <td>{%if city.temperature%}{{city.temperature}} °C{%endif%}</td>
			      <td><div class='row'><a href='{% url "cities:unsubscribe" city.id%}'> - </a></div></td>
			    </tr>
			{%endfor%}
		  </tbody>
		</table>
	</main>
{%endblock%}

templates/base.html
{%load static%}
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="/docs/4.0/assets/img/favicons/favicon.ico">

    <title>Fixed top navbar example for Bootstrap</title>

    <link rel="canonical" href="https://getbootstrap.com/docs/4.0/examples/navbar-fixed/">

    <!-- Bootstrap core CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
	<link rel='stylesheet' href='{%static "cities.css"%}'>

    <!-- Custom styles for this template -->
    <link href="navbar-top-fixed.css" rel="stylesheet">
	{%block extra_css%}
	{%endblock%}
  </head>

  <body>
	{%include 'navbar.html'%}
	{%block content%}{%endblock%}
    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
	<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
  </body>
</html>

templates/navbar.html
<nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark">
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarCollapse">
    <ul class="navbar-nav mr-auto">
      
	  <li class="nav-item">
        {%if user.is_authenticated%}
			<a class="nav-link" href="{%url 'cities:logout'%}">Logout ({{user.username}})</span></a>
		{%else%}
			<a class="nav-link" href="{%url 'cities:login'%}">Login</span></a>
		{%endif%}
      </li>
	  <li class="nav-item">
		<a class="nav-link" href="{%url 'cities:readme'%}">README.md</span></a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{%url 'cities:cities-list'%}">Cities</span></a>
      </li>
		{%if user.is_authenticated%}
          <li class="nav-item">
            <a class="nav-link" href="{%url 'cities:subscriptions-list'%}">Subscriptions</span></a>
          </li>
		{%endif%}
    </ul>
  </div>
	<div class='row'>
		{% if messages %}
		    {% for message in messages %}
		    	<div{% if message.tags %} class="alert alert-{{ message.tags }}"{% endif %}>{{ message }}</div>
		    {% endfor %}
		{% endif %}
	</div>
</nav>